
package com.sunlabs.archsim.fleet.common;


/**
 *
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 * 
 * @author Igor
 *
 * Payload carried through the fleet switch fabric;
 * 
 */

public class Payload implements Cloneable {
	
	public static enum PayloadType { INSTRUCTION, LITERAL, UNKNOWN};

	public static int UNDEFINED= -1;
	
	// -1 indicates a standing move
	public int repeats= 1;
	
	/** the address of the source ship */
	public int source= UNDEFINED;
	/** the address of the destination ship */
	public int destination= UNDEFINED;
	
	/* the data fetched from the source and delivered to the destination */
	public Data data= null;
		
	public PayloadType type= PayloadType.UNKNOWN;
	
	public String toString() {
		return "Payload: src= " + source + ", dest= " + destination
				+ ", data= " + data + " repeats= " + repeats + " type = " + type;
	}
	
	public boolean equals(Object o) {
		boolean answer= false;
		if (o instanceof Payload) {
			Payload p= (Payload)o;
			answer = (this.source == p.source)
				&& (this.destination == p.destination)
				&& ( (this.data == null && p.data == null )
						|| (this.data != null && this.data.equals(p.data)))
				&& (this.type == p.type);
		}
		return answer;
	} // equals
	
	public Object clone() {
		Payload p= new Payload();
		p.repeats= this.repeats;
		p.source= this.source;
		p.destination= this.destination;
		if (data== null) {
			p.data= null;
		}
		else {
			p.data= (Data)(this.data.clone());
		}
		p.type= this.type;
		
		return p;
	}
	
} // Payload
